%define anolis_release 2

Summary: The GNU disk partition manipulation program
Name:    parted
Version: 3.5
Release: %{anolis_release}%{?dist}
License: GPLv3+
URL:     http://www.gnu.org/software/parted

Source0: https://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.xz
Source1: https://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.xz.sig
Source2: pubkey.phillip.susi
Source3: pubkey.brian.lane

#upstream patches
Patch1: 0001-maint-post-release-administrivia.patch
Patch2: 0002-parted-add-type-command.patch
Patch3: 0003-libparted-add-swap-flag-for-DASD-label.patch
Patch4: 0004-parted-Reset-the-filesystem-type-when-changing-the-i.patch
Patch5: 0005-tests-t3200-type-change-now-passes.patch
Patch6: 0006-libparted-Fix-check-for-availability-of-_type_id-fun.patch
Patch7: 0007-parted-Simplify-code-for-json-output.patch
Patch8: 0008-disk.in.h-Remove-use-of-enums-with-define.patch
Patch9: 0009-libparted-Fix-handling-of-gpt-partition-types.patch
Patch10: 0010-tests-Add-a-libparted-test-for-ped_partition_set_sys.patch
Patch11: 0011-libparted-Fix-handling-of-msdos-partition-types.patch
Patch12: 0012-tests-Add-a-libparted-test-for-ped_partition_set_sys.patch
Patch13: 0013-parted-Add-display-of-GPT-UUIDs-in-JSON-output.patch
Patch14: 0014-gpt-Add-no_automount-partition-flag.patch
Patch15: 0015-tests-XFS-requires-a-minimum-size-of-300M.patch

BuildRequires: gcc
BuildRequires: e2fsprogs-devel
BuildRequires: readline-devel
BuildRequires: ncurses-devel
BuildRequires: gettext-devel
BuildRequires: texinfo
BuildRequires: device-mapper-devel
BuildRequires: libuuid-devel
BuildRequires: libblkid-devel >= 2.17
BuildRequires: gnupg2
BuildRequires: git
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool
BuildRequires: e2fsprogs
BuildRequires: xfsprogs
BuildRequires: dosfstools
BuildRequires: perl-Digest-CRC
BuildRequires: bc
Buildrequires: python3
BuildRequires: gperf
BuildRequires: make

# bundled gnulib library exception, as per packaging guidelines
Provides: bundled(gnulib)

%description
The GNU Parted program allows you to create, destroy, resize, move,
and copy hard disk partitions. Parted can be used for creating space
for new operating systems, reorganizing disk usage, and copying data
to new hard disks.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package devel
Summary:  Files for developing apps which will manipulate disk partitions
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
The GNU Parted library is a set of routines for hard disk partition
manipulation. If you want to develop programs that manipulate disk
partitions and filesystems using the routines provided by the GNU
Parted library, you need to install this package.

%prep
%{gpgverify} --keyring='%{SOURCE3}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%autosetup -n %{name}-%{version} -p1
iconv -f ISO-8859-1 -t UTF8 AUTHORS > tmp; touch -r AUTHORS tmp; mv tmp AUTHORS

%build
autoreconf -fiv
CFLAGS="$RPM_OPT_FLAGS -Wno-unused-but-set-variable"; export CFLAGS
%configure --disable-static --disable-gcc-warnings
# Don't use rpath!
%{__sed} -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
%{__sed} -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make_build

%install
%{__rm} -rf %{buildroot}
%make_install

# Remove components we do not ship
%{__rm} -rf %{buildroot}%{_libdir}/*.la
%{__rm} -rf %{buildroot}%{_infodir}/dir
%{__rm} -rf %{buildroot}%{_bindir}/label
%{__rm} -rf %{buildroot}%{_bindir}/disk

%find_lang %{name}

%check
export LD_LIBRARY_PATH=$(pwd)/libparted/.libs:$(pwd)/libparted/fs/.libs
make check

%generate_compatibility_deps

%files -f %{name}.lang
%dir %{abidir}
%{!?_licensedir:%global license %%doc}
%license COPYING
%{_sbindir}/parted
%{_sbindir}/partprobe
%{_mandir}/man8/parted.8.zst
%{_mandir}/man8/partprobe.8.zst
%{_libdir}/libparted.so.2
%{_libdir}/libparted.so.2.0.4
%{_libdir}/libparted-fs-resize.so.0
%{_libdir}/libparted-fs-resize.so.0.0.4
%{_infodir}/parted.info.*
%{abidir}/libparted.dump
%{abidir}/libparted-fs-resize.dump
%{abidir}/parted-option.list
%{abidir}/partprobe-option.list

%files doc
%doc AUTHORS NEWS README THANKS ABOUT-NLS BUGS

%files devel
%doc TODO doc/API doc/FAT
%{_includedir}/parted
%{_libdir}/libparted.so
%{_libdir}/libparted-fs-resize.so
%{_libdir}/pkgconfig/libparted.pc
%{_libdir}/pkgconfig/libparted-fs-resize.pc

%changelog
* Wed Dec 28 2022 Jing Zhang <renyu.zj@linux.alibaba.com> - 3.5-2
- Fix some bugs and add features:
- Fix handling of gpt partition types
- Fix handling of msdos partition types
- Add a libparted test for ped_partition_set_system on msdos
- Add display of GPT UUIDs in JSON output
- Add no_automount flag support
- increase xfs size to 300M etc.

* Fri Sep 23 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.5-1
- update to 3.5

* Fri Mar 04 2022 Hongwei Qin <qhw01063182@alibaba-inc.com> - 3.4-1
- New stable upstream release v3.4
- Init for Anolis OS 23
